<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::storage::sqliteStorage Namespace Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1storage.html">storage</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html">sqliteStorage</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#namespaces">Namespaces</a> &#124;
<a href="#nested-classes">Classes</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::storage::sqliteStorage Namespace Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1test"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1test.html">test</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_database.html">SQLiteDatabase</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_misc_storage.html">SQLiteMiscStorage</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_statement.html">SQLiteStatement</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a62feeb7961c4b55b43ac35b2fe66cdf0"><td class="memItemLeft" align="right" valign="top">sqlite3 *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a62feeb7961c4b55b43ac35b2fe66cdf0">createSQLiteDatabase</a> (const std::string &amp;filePath)</td></tr>
<tr class="separator:a62feeb7961c4b55b43ac35b2fe66cdf0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a268b749423c787170850ae55fb589f74"><td class="memItemLeft" align="right" valign="top">sqlite3 *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a268b749423c787170850ae55fb589f74">openSQLiteDatabase</a> (const std::string &amp;filePath)</td></tr>
<tr class="separator:a268b749423c787170850ae55fb589f74"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4065a4e5f851ff9adc3ed32c61dba963"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a4065a4e5f851ff9adc3ed32c61dba963">closeSQLiteDatabase</a> (sqlite3 *dbHandle)</td></tr>
<tr class="separator:a4065a4e5f851ff9adc3ed32c61dba963"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad0fc61e51b07d23d55a8a4ca4659f476"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#ad0fc61e51b07d23d55a8a4ca4659f476">performQuery</a> (sqlite3 *dbHandle, const std::string &amp;sqlString)</td></tr>
<tr class="separator:ad0fc61e51b07d23d55a8a4ca4659f476"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4a64573a562e76bf44d1d71cfb132f3"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#ae4a64573a562e76bf44d1d71cfb132f3">getNumberTableRows</a> (<a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_database.html">SQLiteDatabase</a> *db, const std::string &amp;tableName, int *numberRows)</td></tr>
<tr class="separator:ae4a64573a562e76bf44d1d71cfb132f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a57b3356f1cdadb940ced1af0c0493980"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a57b3356f1cdadb940ced1af0c0493980">getTableMaxIntValue</a> (<a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_database.html">SQLiteDatabase</a> *db, const std::string &amp;tableName, const std::string &amp;columnName, int *maxId)</td></tr>
<tr class="separator:a57b3356f1cdadb940ced1af0c0493980"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8b7c74efb0b3b32e22e07408c9bd3f60"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a8b7c74efb0b3b32e22e07408c9bd3f60">tableExists</a> (sqlite3 *dbHandle, const std::string &amp;tableName)</td></tr>
<tr class="separator:a8b7c74efb0b3b32e22e07408c9bd3f60"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3d5fe1638fedd28b1a65b21b5a4d5286"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a3d5fe1638fedd28b1a65b21b5a4d5286">clearTable</a> (sqlite3 *dbHandle, const std::string &amp;tableName)</td></tr>
<tr class="separator:a3d5fe1638fedd28b1a65b21b5a4d5286"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a77305534ef1a6a1c0c8a4835709eb858"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a77305534ef1a6a1c0c8a4835709eb858">dropTable</a> (sqlite3 *dbHandle, const std::string &amp;tableName)</td></tr>
<tr class="separator:a77305534ef1a6a1c0c8a4835709eb858"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c7aac9ac5b39d904f722a6128c8331e"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a0c7aac9ac5b39d904f722a6128c8331e">TAG</a> (&quot;SQLiteDatabase&quot;)</td></tr>
<tr class="memdesc:a0c7aac9ac5b39d904f722a6128c8331e"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#a0c7aac9ac5b39d904f722a6128c8331e">More...</a><br /></td></tr>
<tr class="separator:a0c7aac9ac5b39d904f722a6128c8331e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac1dd1935d769d10155c91e2de6a08505"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#ac1dd1935d769d10155c91e2de6a08505">TAG</a> (&quot;SQLiteMiscStorage&quot;)</td></tr>
<tr class="memdesc:ac1dd1935d769d10155c91e2de6a08505"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#ac1dd1935d769d10155c91e2de6a08505">More...</a><br /></td></tr>
<tr class="separator:ac1dd1935d769d10155c91e2de6a08505"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a98b1b8f1b98fbf9a2fedfd762a6da3"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a0a98b1b8f1b98fbf9a2fedfd762a6da3">basicDBChecks</a> (<a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_database.html">SQLiteDatabase</a> &amp;db, const std::string &amp;componentName, const std::string &amp;tableName)</td></tr>
<tr class="separator:a0a98b1b8f1b98fbf9a2fedfd762a6da3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d5db2e088a43f40f6775145feb414b8"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a5d5db2e088a43f40f6775145feb414b8">basicDBChecks</a> (<a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_database.html">SQLiteDatabase</a> &amp;db, const std::string &amp;componentName, const std::string &amp;tableName, bool tableShouldExist)</td></tr>
<tr class="separator:a5d5db2e088a43f40f6775145feb414b8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa792ac68f0574d09bb030883dcb193f6"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#aa792ac68f0574d09bb030883dcb193f6">getDBTableName</a> (const std::string &amp;componentName, const std::string &amp;tableName)</td></tr>
<tr class="separator:aa792ac68f0574d09bb030883dcb193f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a44d7b042f0d14e65c6f41c0ca381e051"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a44d7b042f0d14e65c6f41c0ca381e051">getKeyTypeString</a> (<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1storage_1_1_misc_storage_interface.html#a8dba8c0444a0cc2aaed5b8353c513eea">SQLiteMiscStorage::KeyType</a> keyType)</td></tr>
<tr class="separator:a44d7b042f0d14e65c6f41c0ca381e051"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4f4e86686dc1e49b9bc85c64dc47aacf"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a4f4e86686dc1e49b9bc85c64dc47aacf">getValueTypeString</a> (<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1storage_1_1_misc_storage_interface.html#ab18544389e7b78a72b7a073d52410990">SQLiteMiscStorage::ValueType</a> valueType)</td></tr>
<tr class="separator:a4f4e86686dc1e49b9bc85c64dc47aacf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9358089aa6652c0b315d7f9d45c0ab11"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a9358089aa6652c0b315d7f9d45c0ab11">getDBDataType</a> (const std::string &amp;keyValueType)</td></tr>
<tr class="separator:a9358089aa6652c0b315d7f9d45c0ab11"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af03e0d41a594b73def137d8e069245b3"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#af03e0d41a594b73def137d8e069245b3">escapeValue</a> (const std::string &amp;value)</td></tr>
<tr class="separator:af03e0d41a594b73def137d8e069245b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1cd9d58bedde8bf15e39a50caec3c5f6"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a1cd9d58bedde8bf15e39a50caec3c5f6">TAG</a> (&quot;SQLiteStatement&quot;)</td></tr>
<tr class="memdesc:a1cd9d58bedde8bf15e39a50caec3c5f6"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#a1cd9d58bedde8bf15e39a50caec3c5f6">More...</a><br /></td></tr>
<tr class="separator:a1cd9d58bedde8bf15e39a50caec3c5f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac6d89cebab82ac41dc010088864ce953"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#ac6d89cebab82ac41dc010088864ce953">TAG</a> (&quot;SQLiteUtils&quot;)</td></tr>
<tr class="memdesc:ac6d89cebab82ac41dc010088864ce953"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#ac6d89cebab82ac41dc010088864ce953">More...</a><br /></td></tr>
<tr class="separator:ac6d89cebab82ac41dc010088864ce953"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2a47474bfa8db0122931396d744703ca"><td class="memItemLeft" align="right" valign="top">static sqlite3 *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a2a47474bfa8db0122931396d744703ca">openSQLiteDatabaseHelper</a> (const std::string &amp;filePath, int sqliteFlags)</td></tr>
<tr class="separator:a2a47474bfa8db0122931396d744703ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a59ecba2494f508656c6e39e88326a21d"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a59ecba2494f508656c6e39e88326a21d">KEY_COLUMN_NAME</a> = &quot;key&quot;</td></tr>
<tr class="memdesc:a59ecba2494f508656c6e39e88326a21d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Names of the columns in the database.  <a href="#a59ecba2494f508656c6e39e88326a21d">More...</a><br /></td></tr>
<tr class="separator:a59ecba2494f508656c6e39e88326a21d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7406732969dc0d5bdec749a041344e3a"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a7406732969dc0d5bdec749a041344e3a">VALUE_COLUMN_NAME</a> = &quot;value&quot;</td></tr>
<tr class="separator:a7406732969dc0d5bdec749a041344e3a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a710bef95ede275f2749ff982864b1bd7"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a710bef95ede275f2749ff982864b1bd7">MISC_DATABASE_CONFIGURATION_ROOT_KEY</a> = &quot;miscDatabase&quot;</td></tr>
<tr class="memdesc:a710bef95ede275f2749ff982864b1bd7"><td class="mdescLeft">&#160;</td><td class="mdescRight">The key in our config file to find the root of settings for this database.  <a href="#a710bef95ede275f2749ff982864b1bd7">More...</a><br /></td></tr>
<tr class="separator:a710bef95ede275f2749ff982864b1bd7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a432e2f85cd2d6fdf2b253de3be11848e"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a432e2f85cd2d6fdf2b253de3be11848e">MISC_DATABASE_DB_FILE_PATH_KEY</a> = &quot;databaseFilePath&quot;</td></tr>
<tr class="memdesc:a432e2f85cd2d6fdf2b253de3be11848e"><td class="mdescLeft">&#160;</td><td class="mdescRight">The key in our config file to find the database file path.  <a href="#a432e2f85cd2d6fdf2b253de3be11848e">More...</a><br /></td></tr>
<tr class="separator:a432e2f85cd2d6fdf2b253de3be11848e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5699a7440f98c55f469cfc08e477eb92"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a5699a7440f98c55f469cfc08e477eb92">MISC_DATABASE_DB_COMPONENT_TABLE_NAMES_SEPARATOR</a> = &quot;_&quot;</td></tr>
<tr class="memdesc:a5699a7440f98c55f469cfc08e477eb92"><td class="mdescLeft">&#160;</td><td class="mdescRight">Component and table name separator in DB table name.  <a href="#a5699a7440f98c55f469cfc08e477eb92">More...</a><br /></td></tr>
<tr class="separator:a5699a7440f98c55f469cfc08e477eb92"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac2002ba183c664390266a9548dbb0da2"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#ac2002ba183c664390266a9548dbb0da2">STRING_KEY_VALUE_TYPE</a> = &quot;STRING&quot;</td></tr>
<tr class="memdesc:ac2002ba183c664390266a9548dbb0da2"><td class="mdescLeft">&#160;</td><td class="mdescRight">String key/value type.  <a href="#ac2002ba183c664390266a9548dbb0da2">More...</a><br /></td></tr>
<tr class="separator:ac2002ba183c664390266a9548dbb0da2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a90aa4526a73ebfbf8c9c03a1a009723b"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a90aa4526a73ebfbf8c9c03a1a009723b">UNKNOWN_KEY_VALUE_TYPE</a> = &quot;UNKNOWN&quot;</td></tr>
<tr class="memdesc:a90aa4526a73ebfbf8c9c03a1a009723b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Unknown key/value type.  <a href="#a90aa4526a73ebfbf8c9c03a1a009723b">More...</a><br /></td></tr>
<tr class="separator:a90aa4526a73ebfbf8c9c03a1a009723b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9ecf3c080fdda79f30c5c3de50901d29"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a9ecf3c080fdda79f30c5c3de50901d29">TEXT_DB_TYPE</a> = &quot;TEXT&quot;</td></tr>
<tr class="memdesc:a9ecf3c080fdda79f30c5c3de50901d29"><td class="mdescLeft">&#160;</td><td class="mdescRight">DB type.  <a href="#a9ecf3c080fdda79f30c5c3de50901d29">More...</a><br /></td></tr>
<tr class="separator:a9ecf3c080fdda79f30c5c3de50901d29"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a55d92c9b0d211c0fd211aadd8f6581d6"><td class="memItemLeft" align="right" valign="top">static const bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a55d92c9b0d211c0fd211aadd8f6581d6">CHECK_TABLE_EXISTS</a> = true</td></tr>
<tr class="memdesc:a55d92c9b0d211c0fd211aadd8f6581d6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Boolean to check if table exists.  <a href="#a55d92c9b0d211c0fd211aadd8f6581d6">More...</a><br /></td></tr>
<tr class="separator:a55d92c9b0d211c0fd211aadd8f6581d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a002f5b168baf49fa6132d817c831ccf2"><td class="memItemLeft" align="right" valign="top">static const bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a002f5b168baf49fa6132d817c831ccf2">CHECK_TABLE_NOT_EXISTS</a> = false</td></tr>
<tr class="memdesc:a002f5b168baf49fa6132d817c831ccf2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Boolean to check if table doesn't exist.  <a href="#a002f5b168baf49fa6132d817c831ccf2">More...</a><br /></td></tr>
<tr class="separator:a002f5b168baf49fa6132d817c831ccf2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa5d13694f8d89401a04a013ea0622f94"><td class="memItemLeft" align="right" valign="top">static const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#aa5d13694f8d89401a04a013ea0622f94">SQLITE_BIND_PARAMETER_LEFT_MOST_INDEX</a> = 1</td></tr>
<tr class="separator:aa5d13694f8d89401a04a013ea0622f94"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a303c43ae054b321fb4656b76ca4ba3bf"><td class="memItemLeft" align="right" valign="top">static const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#a303c43ae054b321fb4656b76ca4ba3bf">SQLITE_RESULT_FIELD_LEFT_MOST_INDEX</a> = 0</td></tr>
<tr class="separator:a303c43ae054b321fb4656b76ca4ba3bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af3695dabf7f6da0ac2ddaca876e08f82"><td class="memItemLeft" align="right" valign="top">static const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1storage_1_1sqlite_storage.html#af3695dabf7f6da0ac2ddaca876e08f82">SQLITE_PARSE_STRING_UNTIL_NUL_CHARACTER</a> = -1</td></tr>
<tr class="separator:af3695dabf7f6da0ac2ddaca876e08f82"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="a0a98b1b8f1b98fbf9a2fedfd762a6da3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0a98b1b8f1b98fbf9a2fedfd762a6da3">&#9670;&nbsp;</a></span>basicDBChecks() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::storage::sqliteStorage::basicDBChecks </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_database.html">SQLiteDatabase</a> &amp;&#160;</td>
          <td class="paramname"><em>db</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>componentName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>tableName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Helper method that will check basic things about the DB.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">db</td><td>The <a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_database.html">SQLiteDatabase</a> handle for MiscDB </td></tr>
    <tr><td class="paramname">componentName</td><td>The component name. </td></tr>
    <tr><td class="paramname">tableName</td><td>The table name to check. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>an error message if the checks fail, else a blank string </dd></dl>

</div>
</div>
<a id="a5d5db2e088a43f40f6775145feb414b8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5d5db2e088a43f40f6775145feb414b8">&#9670;&nbsp;</a></span>basicDBChecks() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::storage::sqliteStorage::basicDBChecks </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_database.html">SQLiteDatabase</a> &amp;&#160;</td>
          <td class="paramname"><em>db</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>componentName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>tableName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>tableShouldExist</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Helper method that will check basic things about the DB.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">db</td><td>The <a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_database.html">SQLiteDatabase</a> handle for MiscDB </td></tr>
    <tr><td class="paramname">componentName</td><td>The component name. </td></tr>
    <tr><td class="paramname">tableName</td><td>The table name to check. </td></tr>
    <tr><td class="paramname">tableShouldExist</td><td>If true, checks if the table should exist. If false, it checks the opposite. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>an error message if the checks fail, else a blank string </dd></dl>

</div>
</div>
<a id="a3d5fe1638fedd28b1a65b21b5a4d5286"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3d5fe1638fedd28b1a65b21b5a4d5286">&#9670;&nbsp;</a></span>clearTable()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::storage::sqliteStorage::clearTable </td>
          <td>(</td>
          <td class="paramtype">sqlite3 *&#160;</td>
          <td class="paramname"><em>dbHandle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>tableName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Deletes all records from a table.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dbHandle</td><td>A SQLite handle to an open database. </td></tr>
    <tr><td class="paramname">tableName</td><td>The name of the table from which all rows should be deleted. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the table was cleared successfully. </dd></dl>

</div>
</div>
<a id="a4065a4e5f851ff9adc3ed32c61dba963"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4065a4e5f851ff9adc3ed32c61dba963">&#9670;&nbsp;</a></span>closeSQLiteDatabase()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::storage::sqliteStorage::closeSQLiteDatabase </td>
          <td>(</td>
          <td class="paramtype">sqlite3 *&#160;</td>
          <td class="paramname"><em>dbHandle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Closes a SQLite database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">The</td><td>handle to sqlite database. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the operation was successful. </dd></dl>

</div>
</div>
<a id="a62feeb7961c4b55b43ac35b2fe66cdf0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a62feeb7961c4b55b43ac35b2fe66cdf0">&#9670;&nbsp;</a></span>createSQLiteDatabase()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">sqlite3 * alexaClientSDK::storage::sqliteStorage::createSQLiteDatabase </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filePath</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Creates a SQLite database at the given filePath. If a file at the given path already exists, this function will fail.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filePath</td><td>The location where the database should be created. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the created sqlite database. If it could not be created, <code>nullptr</code> is returned. </dd></dl>

</div>
</div>
<a id="a77305534ef1a6a1c0c8a4835709eb858"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a77305534ef1a6a1c0c8a4835709eb858">&#9670;&nbsp;</a></span>dropTable()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::storage::sqliteStorage::dropTable </td>
          <td>(</td>
          <td class="paramtype">sqlite3 *&#160;</td>
          <td class="paramname"><em>dbHandle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>tableName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Drops a table from the database. Important note - per SQL mechanics, this single command will erase all records that may be stored in the table being dropped. This action cannot be undone.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dbHandle</td><td>A SQLite handle to an open database. </td></tr>
    <tr><td class="paramname">tableName</td><td>The name of the table to be dropped. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the table was dropped successfully. </dd></dl>

</div>
</div>
<a id="af03e0d41a594b73def137d8e069245b3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af03e0d41a594b73def137d8e069245b3">&#9670;&nbsp;</a></span>escapeValue()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::storage::sqliteStorage::escapeValue </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Escapes the value of a database entry so that it can be inserted into an SQL query.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>The value of a database entry to escape. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The escaped database value. </dd></dl>

</div>
</div>
<a id="a9358089aa6652c0b315d7f9d45c0ab11"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9358089aa6652c0b315d7f9d45c0ab11">&#9670;&nbsp;</a></span>getDBDataType()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::storage::sqliteStorage::getDBDataType </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>keyValueType</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Gets the DB type given a key/value type.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">keyValueType</td><td>The key/value type as a string. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the DB type </dd></dl>

</div>
</div>
<a id="aa792ac68f0574d09bb030883dcb193f6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa792ac68f0574d09bb030883dcb193f6">&#9670;&nbsp;</a></span>getDBTableName()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::storage::sqliteStorage::getDBTableName </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>componentName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>tableName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Helper method that will get the table name as it is in the DB. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">componentName</td><td>The component name. </td></tr>
    <tr><td class="paramname">tableName</td><td>The table name to check</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the table name as it is in the DB, else a blank string </dd></dl>

</div>
</div>
<a id="a44d7b042f0d14e65c6f41c0ca381e051"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a44d7b042f0d14e65c6f41c0ca381e051">&#9670;&nbsp;</a></span>getKeyTypeString()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::storage::sqliteStorage::getKeyTypeString </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1storage_1_1_misc_storage_interface.html#a8dba8c0444a0cc2aaed5b8353c513eea">SQLiteMiscStorage::KeyType</a>&#160;</td>
          <td class="paramname"><em>keyType</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Gets the key type as a string</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">keyType</td><td>The key type enum. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the key type as a string </dd></dl>

</div>
</div>
<a id="ae4a64573a562e76bf44d1d71cfb132f3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae4a64573a562e76bf44d1d71cfb132f3">&#9670;&nbsp;</a></span>getNumberTableRows()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::storage::sqliteStorage::getNumberTableRows </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_database.html">SQLiteDatabase</a> *&#160;</td>
          <td class="paramname"><em>db</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>tableName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>numberRows</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Acquires the number of rows in a table within an open database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">db</td><td>A SQLite database object. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">tableName</td><td>The name of the table to be queried. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">numberRows</td><td>Where the number of rows will be stored on a successful lookup. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the lookup was successful or not. </dd></dl>

</div>
</div>
<a id="a57b3356f1cdadb940ced1af0c0493980"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a57b3356f1cdadb940ced1af0c0493980">&#9670;&nbsp;</a></span>getTableMaxIntValue()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::storage::sqliteStorage::getTableMaxIntValue </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1storage_1_1sqlite_storage_1_1_s_q_lite_database.html">SQLiteDatabase</a> *&#160;</td>
          <td class="paramname"><em>db</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>tableName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>columnName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>maxId</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Queries a specified column in a SQLite table, and identifies the highest value across all rows. This function requires that the table and column exists, and that the column is of integer type.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">db</td><td>A SQLite database object. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">tableName</td><td>The name of the table to be queried. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">columnName</td><td>The name of the column in the table to be queried. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">maxId</td><td>Where the maximum id will be stored on a successful lookup. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the lookup was successful or not. </dd></dl>

</div>
</div>
<a id="a4f4e86686dc1e49b9bc85c64dc47aacf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4f4e86686dc1e49b9bc85c64dc47aacf">&#9670;&nbsp;</a></span>getValueTypeString()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::storage::sqliteStorage::getValueTypeString </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1storage_1_1_misc_storage_interface.html#ab18544389e7b78a72b7a073d52410990">SQLiteMiscStorage::ValueType</a>&#160;</td>
          <td class="paramname"><em>valueType</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Gets the value type as a string.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">valueType</td><td>The value type enum. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the value type as a string </dd></dl>

</div>
</div>
<a id="a268b749423c787170850ae55fb589f74"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a268b749423c787170850ae55fb589f74">&#9670;&nbsp;</a></span>openSQLiteDatabase()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">sqlite3 * alexaClientSDK::storage::sqliteStorage::openSQLiteDatabase </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filePath</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Opens a SQLite database that will be stored at the given (already existing) filePath. If the database file does not already exist at the given filePath, this function will fail.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filePath</td><td>The location of the database file to be opened. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the opened sqlite database. If it could not be opened, <code>nullptr</code> is returned. </dd></dl>

</div>
</div>
<a id="a2a47474bfa8db0122931396d744703ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2a47474bfa8db0122931396d744703ca">&#9670;&nbsp;</a></span>openSQLiteDatabaseHelper()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static sqlite3* alexaClientSDK::storage::sqliteStorage::openSQLiteDatabaseHelper </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filePath</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>sqliteFlags</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">A utility function to open or create a SQLite database, depending on the flags being passed in. The possible flags defined by SQLite for this operation are as follows:</p>
<p class="">SQLITE_OPEN_READONLY SQLITE_OPEN_READWRITE SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE</p>
<p class="">The meanings of these flags are as one might expect, however for further details please refer to the online documentation here:</p>
<p class=""><a href="https://sqlite.org/c3ref/open.html">https://sqlite.org/c3ref/open.html</a></p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">filePath</td><td>The path, including file name, to where the database is to be opened or created. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">sqliteFlags</td><td>Flags which will be passed to the SQLite call. These flags determine the method of opening. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">dbHandle</td><td>A double-pointer to a sqlite3 handle which will be updated to point to a valid handle. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the operation was successful. </dd></dl>

</div>
</div>
<a id="ad0fc61e51b07d23d55a8a4ca4659f476"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad0fc61e51b07d23d55a8a4ca4659f476">&#9670;&nbsp;</a></span>performQuery()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::storage::sqliteStorage::performQuery </td>
          <td>(</td>
          <td class="paramtype">sqlite3 *&#160;</td>
          <td class="paramname"><em>dbHandle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>sqlString</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Performs a SQL query, and does not inspect any result. This is an appropriate function to call for simple queries, which do not require bound parameters, such as when creating tables in a database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dbHandle</td><td>A SQLite handle to an open database. </td></tr>
    <tr><td class="paramname">sqlString</td><td>The SQL string which contains the full query to be performed. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the query was successfully performed. </dd></dl>

</div>
</div>
<a id="a8b7c74efb0b3b32e22e07408c9bd3f60"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8b7c74efb0b3b32e22e07408c9bd3f60">&#9670;&nbsp;</a></span>tableExists()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::storage::sqliteStorage::tableExists </td>
          <td>(</td>
          <td class="paramtype">sqlite3 *&#160;</td>
          <td class="paramname"><em>dbHandle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>tableName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Queries if a table exists within a given open database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dbHandle</td><td>A SQLite handle to an open database. </td></tr>
    <tr><td class="paramname">tableName</td><td>The name of the table to be tested for. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the table exists. </dd></dl>

</div>
</div>
<a id="a1cd9d58bedde8bf15e39a50caec3c5f6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1cd9d58bedde8bf15e39a50caec3c5f6">&#9670;&nbsp;</a></span>TAG() <span class="overload">[1/4]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::storage::sqliteStorage::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;SQLiteStatement&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="a0c7aac9ac5b39d904f722a6128c8331e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0c7aac9ac5b39d904f722a6128c8331e">&#9670;&nbsp;</a></span>TAG() <span class="overload">[2/4]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::storage::sqliteStorage::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;SQLiteDatabase&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="ac6d89cebab82ac41dc010088864ce953"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac6d89cebab82ac41dc010088864ce953">&#9670;&nbsp;</a></span>TAG() <span class="overload">[3/4]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::storage::sqliteStorage::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;SQLiteUtils&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="ac1dd1935d769d10155c91e2de6a08505"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac1dd1935d769d10155c91e2de6a08505">&#9670;&nbsp;</a></span>TAG() <span class="overload">[4/4]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::storage::sqliteStorage::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;SQLiteMiscStorage&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="a55d92c9b0d211c0fd211aadd8f6581d6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a55d92c9b0d211c0fd211aadd8f6581d6">&#9670;&nbsp;</a></span>CHECK_TABLE_EXISTS</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const bool alexaClientSDK::storage::sqliteStorage::CHECK_TABLE_EXISTS = true</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Boolean to check if table exists. </p>

</div>
</div>
<a id="a002f5b168baf49fa6132d817c831ccf2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a002f5b168baf49fa6132d817c831ccf2">&#9670;&nbsp;</a></span>CHECK_TABLE_NOT_EXISTS</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const bool alexaClientSDK::storage::sqliteStorage::CHECK_TABLE_NOT_EXISTS = false</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Boolean to check if table doesn't exist. </p>

</div>
</div>
<a id="a59ecba2494f508656c6e39e88326a21d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a59ecba2494f508656c6e39e88326a21d">&#9670;&nbsp;</a></span>KEY_COLUMN_NAME</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::storage::sqliteStorage::KEY_COLUMN_NAME = &quot;key&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Names of the columns in the database. </p>

</div>
</div>
<a id="a710bef95ede275f2749ff982864b1bd7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a710bef95ede275f2749ff982864b1bd7">&#9670;&nbsp;</a></span>MISC_DATABASE_CONFIGURATION_ROOT_KEY</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::storage::sqliteStorage::MISC_DATABASE_CONFIGURATION_ROOT_KEY = &quot;miscDatabase&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The key in our config file to find the root of settings for this database. </p>

</div>
</div>
<a id="a5699a7440f98c55f469cfc08e477eb92"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5699a7440f98c55f469cfc08e477eb92">&#9670;&nbsp;</a></span>MISC_DATABASE_DB_COMPONENT_TABLE_NAMES_SEPARATOR</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::storage::sqliteStorage::MISC_DATABASE_DB_COMPONENT_TABLE_NAMES_SEPARATOR = &quot;_&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Component and table name separator in DB table name. </p>

</div>
</div>
<a id="a432e2f85cd2d6fdf2b253de3be11848e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a432e2f85cd2d6fdf2b253de3be11848e">&#9670;&nbsp;</a></span>MISC_DATABASE_DB_FILE_PATH_KEY</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::storage::sqliteStorage::MISC_DATABASE_DB_FILE_PATH_KEY = &quot;databaseFilePath&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The key in our config file to find the database file path. </p>

</div>
</div>
<a id="aa5d13694f8d89401a04a013ea0622f94"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa5d13694f8d89401a04a013ea0622f94">&#9670;&nbsp;</a></span>SQLITE_BIND_PARAMETER_LEFT_MOST_INDEX</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const int alexaClientSDK::storage::sqliteStorage::SQLITE_BIND_PARAMETER_LEFT_MOST_INDEX = 1</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="af3695dabf7f6da0ac2ddaca876e08f82"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af3695dabf7f6da0ac2ddaca876e08f82">&#9670;&nbsp;</a></span>SQLITE_PARSE_STRING_UNTIL_NUL_CHARACTER</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const int alexaClientSDK::storage::sqliteStorage::SQLITE_PARSE_STRING_UNTIL_NUL_CHARACTER = -1</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a303c43ae054b321fb4656b76ca4ba3bf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a303c43ae054b321fb4656b76ca4ba3bf">&#9670;&nbsp;</a></span>SQLITE_RESULT_FIELD_LEFT_MOST_INDEX</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const int alexaClientSDK::storage::sqliteStorage::SQLITE_RESULT_FIELD_LEFT_MOST_INDEX = 0</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ac2002ba183c664390266a9548dbb0da2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac2002ba183c664390266a9548dbb0da2">&#9670;&nbsp;</a></span>STRING_KEY_VALUE_TYPE</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::storage::sqliteStorage::STRING_KEY_VALUE_TYPE = &quot;STRING&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String key/value type. </p>

</div>
</div>
<a id="a9ecf3c080fdda79f30c5c3de50901d29"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9ecf3c080fdda79f30c5c3de50901d29">&#9670;&nbsp;</a></span>TEXT_DB_TYPE</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::storage::sqliteStorage::TEXT_DB_TYPE = &quot;TEXT&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>DB type. </p>

</div>
</div>
<a id="a90aa4526a73ebfbf8c9c03a1a009723b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a90aa4526a73ebfbf8c9c03a1a009723b">&#9670;&nbsp;</a></span>UNKNOWN_KEY_VALUE_TYPE</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::storage::sqliteStorage::UNKNOWN_KEY_VALUE_TYPE = &quot;UNKNOWN&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Unknown key/value type. </p>

</div>
</div>
<a id="a7406732969dc0d5bdec749a041344e3a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7406732969dc0d5bdec749a041344e3a">&#9670;&nbsp;</a></span>VALUE_COLUMN_NAME</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::storage::sqliteStorage::VALUE_COLUMN_NAME = &quot;value&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
